LeetCode上“最简单”的一道题了吧?
长时间没有写过题,面试的时候竟然不会写了,奇耻大辱的一件事!
You are given two integer arrays nums1
and nums2
, sorted in non-decreasing order, and two integers m
and n
, representing the number of elements in nums1
and nums2
respectively.
Merge nums1
and nums2
into a single array sorted in non-decreasing order.
The final sorted array should not be returned by the function, but instead be stored inside the array nums1
. To accommodate this, nums1
has a length of m + n
, where the first m
elements denote the elements that should be merged, and the last n
elements are set to 0
and should be ignored. nums2
has a length of n
.
Example 1:
Input: nums1 = [1,2,3,0,0,0], m = 3, nums2 = [2,5,6], n = 3
Output: [1,2,2,3,5,6]
Explanation: The arrays we are merging are [1,2,3] and [2,5,6].
The result of the merge is [1,2,2,3,5,6] with the underlined elements coming from nums1.
Example 2:
Input: nums1 = [1], m = 1, nums2 = [], n = 0
Output: [1]
Explanation: The arrays we are merging are [1] and [].
The result of the merge is [1].
Example 3:
Input: nums1 = [0], m = 0, nums2 = [1], n = 1
Output: [1]
Explanation: The arrays we are merging are [] and [1].
The result of the merge is [1].
Note that because m = 0, there are no elements in nums1. The 0 is only there to ensure the merge result can fit in nums1.
Constraints:
nums1.length == m + n
nums2.length == n
0 <= m, n <= 200
1 <= m + n <= 200
-109 <= nums1[i], nums2[j] <= 109
给你两个按 非递减顺序 排列的整数数组 nums1
和 nums2
,另有两个整数 m
和 n
,分别表示 nums1
和 nums2
中的元素数目。
请你 合并 nums2
到 nums1
中,使合并后的数组同样按 非递减顺序 排列。
注意: 最终,合并后数组不应由函数返回,而是存储在数组 nums1
中。为了应对这种情况,nums1
的初始长度为 m + n
,其中前 m
个元素表示应合并的元素,后 n
个元素为 0
,应忽略。nums2
的长度为 n
。
示例 1:
输入:nums1 = [1,2,3,0,0,0], m = 3, nums2 = [2,5,6], n = 3
输出:[1,2,2,3,5,6]
解释:需要合并 [1,2,3] 和 [2,5,6] 。
合并结果是 [1,2,2,3,5,6] ,其中斜体加粗标注的为 nums1 中的元素。
示例 2:
输入:nums1 = [1], m = 1, nums2 = [], n = 0
输出:[1]
解释:需要合并 [1] 和 [] 。
合并结果是 [1] 。
示例 3:
输入:nums1 = [0], m = 0, nums2 = [1], n = 1
输出:[1]
解释:需要合并的数组是 [] 和 [1] 。
合并结果是 [1] 。
注意,因为 m = 0 ,所以 nums1 中没有元素。nums1 中仅存的 0 仅仅是为了确保合并结果可以顺利存放到 nums1 中。
提示:
nums1.length == m + n
nums2.length == n
0 <= m, n <= 200
1 <= m + n <= 200
-109 <= nums1[i], nums2[j] <= 109
直接使用“双指针”的写法!
(你还记得你多年未写算法题,想到了双指针,结果一上来写了两个for的蠢事嘛🤣)
🥬直接上菜
从两个数组的末尾开始,每次取两者之中较大的数,放到 nums1 的合适位置。这样,当 nums2 被完全复制到 nums1 后,合并就完成了,因为 nums1 和 nums2 本来就是有序的。
下面是详细的步骤:
- 初始化两个指针
p1
和p2
分别指向nums1
和nums2
的有数值的末尾,即p1 = m - 1
,p2 = n - 1
。同时,初始化p
指向nums1
的末尾,即p = m + n - 1
。 - 比较
p1
和p2
指向的值,将较大的值放在p
位置上,并移动指针p
和被选中的p1
或p2
。 - 如果
p2
>= 0 而p1
< 0,意味着nums1
已经被遍历完,但nums2
还有元素未被复制过去,此时直接将nums2
的剩余元素复制到nums1
的前面。 - 如果
p1
>= 0 而p2
< 0,意味着nums2
已经被遍历完,nums1
的剩余元素已经在正确的位置,不需要做任何操作。
下面是用C++实现的代码示例:
// 88. Merge Sorted Array
#include <iostream>
#include <vector>
using namespace std;
// 逆向双指针
class Solution {
public:
void merge(vector<int>& nums1, int m, vector<int>& nums2, int n) {
// 确定终点指针
// 合并后留下nums1数组
int p1 = m - 1, p2 = n - 1, p = m + n - 1;
// 因为已经排序,逆向考虑就是从大往小
while (p1 >= 0 && p2 >= 0) {
if (nums1[p1] > nums2[p2]) {
// 从后往前,先安排大的
nums1[p--] = nums1[p1--];
} else {
nums1[p--] = nums2[p2--];
}
}
// //这时候再看p1和p2谁大于零
// 其实只要看p2是不是大于零就行,因为是从nums2合并到nums1
while (p2 >= 0) {
nums1[p--] = nums2[p2--];
}
}
};
// 这道题可以直接把两个vector加起来,然后一个sort()解决
这段代码通过从后向前遍历 nums1
和 nums2
,避免了合并时覆盖 nums1
中未被检查的元素,同时减少了需要移动元素的次数。
时间复杂度为 O(m+n),空间复杂度为 O(1),因为它不需要额外的存储空间。